#include "Target.h"

// constructor
Target::Target( sc_module_name name )
    : sc_module( name ) 
    , t_socket( "t_soket" )
{
    t_socket.bind( *this );  // I/FȥХ

    Reg = new unsigned int [REG_SIZE];
}

// destructor
Target::~Target()
{
    delete [] Reg;
}

void Target::b_transport( tlm::tlm_generic_payload &trans, sc_time &time ) 
{
    unsigned int address = static_cast<unsigned int>(trans.get_address());
    unsigned int *data_ptr = reinterpret_cast<unsigned int*>(trans.get_data_ptr());

    unsigned int idx = address/4;

    if (idx < REG_SIZE) {
        if (trans.is_read()) {
            // Read
            *data_ptr = Reg[idx];
            trans.set_response_status( tlm::TLM_OK_RESPONSE );
        }
        else {
            // Write
            Reg[idx] = *data_ptr;
            trans.set_response_status( tlm::TLM_OK_RESPONSE );
        }
    }
    else {
        cout << " Address Error: " << "addr=" << hex << address
            << " (MAX_SIZE=" << REG_SIZE << ")" << endl;
        trans.set_response_status( tlm::TLM_ADDRESS_ERROR_RESPONSE  ); 
    }
}

tlm::tlm_sync_enum Target::nb_transport_fw(
        tlm::tlm_generic_payload &trans,
        tlm::tlm_phase &phase,
        sc_time &time )
{
    cout << "nb_transport_fw is not supoorted." << endl;
    trans.set_response_status( tlm::TLM_GENERIC_ERROR_RESPONSE );

    return tlm::TLM_COMPLETED;
}

unsigned int Target::transport_dbg( tlm::tlm_generic_payload &trans )
{
    return 0;  // Debug not supported
}

bool Target::get_direct_mem_ptr( tlm::tlm_generic_payload &trans, tlm::tlm_dmi& dmi)
{
    return false; // DMI not supported
}
